/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Database.xs. Do not edit this file, edit Database.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

/* Autogenerated XS functions are static. */
#define XSUBPP_STATIC_XS

#line 1 "RPM/Database.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <fcntl.h>
#include "RPM.h"

/*
  rpmdb_TIEHASH

  This is the implementation of the tied-hash class constructor. The XS
  wrapper will verify that the value of class is correct, then massage the
  arguments as needed. The return value is expected to be either NULL or a
  valid RPM__Database value (which the XS wrapper will fix up).
*/
RPM__Database rpmdb_TIEHASH(pTHX_ char* class, SV* opts)
{
    char*  root  = (char *)NULL;
    int    mode  = O_RDONLY;
    mode_t perms = 0;
    HV*    opt_hash;
    SV**   svp;
    RPM_Database* retvalp; /* For "private" */

    if (opts)
    {
        if (SvROK(opts) && (SvTYPE(opts) == SVt_PVHV))
        {
            /* This is a hash reference. We are concerned only with
               the key "root". "mode" and "perms" don't apply, as we are
               going to open the database as read-only. */
            opt_hash = (HV*)SvRV(opts);

            svp = hv_fetch(opt_hash, "root", 4, FALSE);
            if (svp && SvPOK(*svp))
                root = SvPV_nolen(*svp);
        }
        else if (SvPOK(opts))
        {
            /* They passed a scalar, assumed to be the "root" */
            root = SvPV_nolen(opts);
        }
        else
        {
            rpmError(RPMERR_BADARG, "Wrong type for argument 2 to TIEHASH");
            return (Null(RPM__Database));
        }
    }

    /* With that all processed, attempt to open the actual RPM DB */
    /* The retvalp is used for the C-level rpmlib information on databases */
    Newz(0, retvalp, 1, RPM_Database);
    if (rpmdbOpen(root, &retvalp->dbp, mode, perms) != 0)
    {
        Safefree(retvalp);
        /* rpm lib will have set the error already */
        return (Null(RPM__Database));
    }

    return retvalp;
}

RPM__Header rpmdb_FETCH(pTHX_ RPM__Database dbstruct, const char *name)
{
    Header h, hi;
    rpmdbMatchIterator mi;
    RPM__Header hdr = Null(RPM__Header);

    h = Null(Header);
    mi = rpmdbInitIterator(dbstruct->dbp, RPMTAG_NAME, name, 0);
    while ((hi = rpmdbNextIterator(mi)) != Null(Header))
    {
        /* There might be more than one match. Find the newest one. */
        if (h == Null(Header) || rpmVersionCompare(hi, h) == 1)
        {
            headerFree(h);
            h = headerLink(hi);
        }
    }
    rpmdbFreeIterator(mi);
    if (h)
        hdr = rpmhdr_TIEHASH_header(aTHX_ h);
    return hdr;
}

bool rpmdb_EXISTS(pTHX_ RPM__Database dbstruct, const char *name)
{
    RPM__Header hdr = rpmdb_FETCH(aTHX_ dbstruct, name);
    if (hdr) {
        rpmhdr_DESTROY(aTHX_ hdr);
        return TRUE;
    }
    return FALSE;
}

int rpmdb_FIRSTKEY(pTHX_ RPM__Database db, const char **namep, RPM__Header *hdrp)
{
    if (db->iterator)
        rpmdbFreeIterator(db->iterator);
    db->iterator = rpmdbInitIterator(db->dbp, RPMDBI_PACKAGES, NULL, 0);
    if (! db->iterator) {
        warn("%s: rpmdbInitIterator() failed", "RPM::Database::FIRSTKEY");
        return 0;
    }
    return rpmdb_NEXTKEY(aTHX_ db, Nullch, namep, hdrp);
}

int rpmdb_NEXTKEY(pTHX_ RPM__Database db, const char *prev_name,
                  const char **namep, RPM__Header *hdrp)
{
    Header h;
    (void) prev_name;
    if (! db->iterator) {
        warn("%s called before FIRSTKEY", "RPM::Database::NEXTKEY");
        return 0;
    }
    if (! (h = rpmdbNextIterator(db->iterator))) {
        /* That was last package.  Game over. */
        rpmdbFreeIterator(db->iterator);
        db->iterator = Null(rpmdbMatchIterator);
        return 0;
    }
    h = headerLink(h);
    *hdrp = rpmhdr_TIEHASH_header(aTHX_ h);
    *namep = (*hdrp)->name;
    return 1;
}

void rpmdb_DESTROY(pTHX_ RPM__Database db)
{
    if (db->iterator)
        rpmdbFreeIterator(db->iterator);
    rpmdbClose(db->dbp);
    Safefree(db);
}

#line 151 "RPM/Database.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 203 "RPM/Database.c"
static
XS(XS_RPM__Database_TIEHASH)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, opts=NULL");
    {
	char*	class = (char *)SvPV_nolen(ST(0));
	SV*	opts;
	RPM__Database	RETVAL;

	if (items < 2)
	    opts = NULL;
	else {
	    opts = ST(1);
	}
#line 147 "RPM/Database.xs"
    RETVAL = rpmdb_TIEHASH(aTHX_ class, opts);
#line 226 "RPM/Database.c"
        ST(0) = rpm_ptr2hvref(aTHX_ RETVAL, "RPM::Database");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_FETCH)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	RPM__Database	self;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	RPM__Header	RETVAL;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::FETCH",
                        "self", "RPM::Database");
    };
#line 157 "RPM/Database.xs"
    RETVAL = rpmdb_FETCH(aTHX_ self, name);
#line 258 "RPM/Database.c"
        ST(0) = rpm_ptr2hvref(aTHX_ RETVAL, "RPM::Header");

	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_STORE)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 3)
       croak_xs_usage(cv,  "self=NULL, key=NULL, value=NULL");
    {
	SV*	self;
	SV*	key;
	SV*	value;
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    self = NULL;
	else {
	    self = ST(0);
	}

	if (items < 2)
	    key = NULL;
	else {
	    key = ST(1);
	}

	if (items < 3)
	    value = NULL;
	else {
	    value = ST(2);
	}
#line 168 "RPM/Database.xs"
    {
        rpmError(RPMERR_NOCREATEDB, "STORE: operation not permitted");
        RETVAL = 0;
    }
#line 305 "RPM/Database.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_DELETE)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 2)
       croak_xs_usage(cv,  "self=NULL, key=NULL");
    {
	SV*	self;
	SV*	key;
	SV *	RETVAL;

	if (items < 1)
	    self = NULL;
	else {
	    self = ST(0);
	}

	if (items < 2)
	    key = NULL;
	else {
	    key = ST(1);
	}
#line 181 "RPM/Database.xs"
    {
        rpmError(RPMERR_NOCREATEDB, "DELETE: operation not permitted");
        RETVAL = Nullsv;
    }
#line 342 "RPM/Database.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_CLEAR)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "self=NULL");
    {
	SV*	self;
	int	RETVAL;
	dXSTARG;

	if (items < 1)
	    self = NULL;
	else {
	    self = ST(0);
	}
#line 193 "RPM/Database.xs"
    {
        rpmError(RPMERR_NOCREATEDB, "CLEAR: operation not permitted");
        RETVAL = 0;
    }
#line 374 "RPM/Database.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_EXISTS)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "self, name");
    {
	RPM__Database	self;
	const char *	name = (const char *)SvPV_nolen(ST(1));
	bool	RETVAL;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::EXISTS",
                        "self", "RPM::Database");
    };
#line 206 "RPM/Database.xs"
    RETVAL = rpmdb_EXISTS(aTHX_ self, name);
#line 404 "RPM/Database.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_FIRSTKEY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	RPM__Database	self;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::FIRSTKEY",
                        "self", "RPM::Database");
    };
#line 215 "RPM/Database.xs"
    {
        const char *name;
        RPM__Header hdr;

        if (rpmdb_FIRSTKEY(aTHX_ self, &name, &hdr))
        {
            EXTEND(SP, 2);
            PUSHs(sv_2mortal(rpm_ptr2hvref(aTHX_ hdr, "RPM::Header")));
            PUSHs(sv_2mortal(newSVpv(name, 0)));
        }

    }
#line 446 "RPM/Database.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_RPM__Database_NEXTKEY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, prev_name=NULL");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	RPM__Database	self;
	const char *	prev_name;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::NEXTKEY",
                        "self", "RPM::Database");
    };

	if (items < 2)
	    prev_name = NULL;
	else {
	    prev_name = (const char *)SvPV_nolen(ST(1));
	}
#line 234 "RPM/Database.xs"
    {
        const char *name;
        RPM__Header hdr;

        if (rpmdb_NEXTKEY(aTHX_ self, prev_name, &name, &hdr))
        {
            EXTEND(SP, 2);
            PUSHs(sv_2mortal(rpm_ptr2hvref(aTHX_ hdr, "RPM::Header")));
            PUSHs(sv_2mortal(newSVpv(name, 0)));
        }

    }
#line 494 "RPM/Database.c"
	PUTBACK;
	return;
    }
}

static
XS(XS_RPM__Database_DESTROY)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	RPM__Database	self;

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        "RPM::Database::DESTROY",
                        "self", "RPM::Database");
    };
#line 252 "RPM/Database.xs"
    rpmdb_DESTROY(aTHX_ self);
#line 522 "RPM/Database.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_RPM__Database_init)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "class, root=NULL, perms=O_RDWR");
    {
	SV*	class = ST(0);
	const char*	root;
	int	perms;
	bool	RETVAL;

	if (items < 2)
	    root = NULL;
	else {
	    root = (const char *)SvPV_nolen(ST(1));
	}

	if (items < 3)
	    perms = O_RDWR;
	else {
	    perms = (int)SvIV(ST(2));
	}
#line 261 "RPM/Database.xs"
    if (SvPOK(class) && strEQ(SvPV_nolen(class), "RPM::Database"))
        RETVAL = !rpmdbInit(root, perms);
    else {
        rpmError(RPMERR_BADARG, "%s must be called as a static method",
                                "RPM::Database::init");
        RETVAL = FALSE;
    }
#line 562 "RPM/Database.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_rebuild)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "class, root=NULL");
    {
	SV*	class = ST(0);
	const char*	root;
	bool	RETVAL;

	if (items < 2)
	    root = NULL;
	else {
	    root = (const char *)SvPV_nolen(ST(1));
	}
#line 277 "RPM/Database.xs"
    if (SvPOK(class) && strEQ(SvPV_nolen(class), "RPM::Database"))
#if RPM_VERSION >= 0x040100
        RETVAL = !rpmdbRebuild(root, NULL, NULL);
#else
        RETVAL = !rpmdbRebuild(root);
#endif
    else {
        rpmError(RPMERR_BADARG, "%s must be called as a static method",
                                "RPM::Database::rebuild");
        RETVAL = FALSE;
    }
#line 601 "RPM/Database.c"
	ST(0) = boolSV(RETVAL);
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Database_find_by_file)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "self, string");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	RPM__Database	self;
	SV *	string = ST(1);

    {
        self = rpm_hvref2ptr(aTHX_ ST(0), "RPM::Database");
        if (!self)
            Perl_croak(aTHX_ "%s: %s is not of type %s",
                        GvNAME(CvGV(cv)),
                        "self", "RPM::Database");
    };
#line 303 "RPM/Database.xs"
    /* This is a front-end to all the rpmdbFindBy*() set, including FindByPackage
       which differs from FETCH above in that if there is actually more than one
       match, all will be returned.  */
    {
        const char *str = Nullch;
        RPM_Header *hdr;

        if (ix == 0)
            ix = RPMTAG_BASENAMES;

        hdr = rpm_hvref2ptr(aTHX_ string, "RPM::Header");
        if (hdr)
            str = hdr->name;
        else
            str = SvPV_nolen(string);

        if (! (str && *str)) {
            rpmError(RPMERR_BADARG, "%s: arg 2 must be either a string"
                     " or valid RPM::Header object", GvNAME(CvGV(cv)));
        /*  Perl_warn(aTHX_ "%s", SvPV_nolen(rpm_errSV)); */
        }
        else {
            rpmdbMatchIterator mi = rpmdbInitIterator(self->dbp, ix, str, 0);
            if (mi) {
                Header h;
                int n = rpmdbGetIteratorCount(mi);
                EXTEND(SP, n);
                while ((h = rpmdbNextIterator(mi)) != Null(Header)) {
                    h = headerLink(h);
                    hdr = rpmhdr_TIEHASH_header(aTHX_ h);
                    PUSHs(sv_2mortal(rpm_ptr2hvref(aTHX_ hdr, "RPM::Header")));
                }
                rpmdbFreeIterator(mi);
            }
        }
    }
#line 669 "RPM/Database.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
#if (__GNUC__ >= 4) && defined(__ELF__)
XS(boot_RPM__Database) __attribute__((visibility("default")));
#else
XS(boot_RPM__Database); /* prototype to pass -Wmissing-prototypes */
#endif
XS(boot_RPM__Database)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

    {
        CV * cv ;

        (void)newXSproto_portable("RPM::Database::TIEHASH", XS_RPM__Database_TIEHASH, file, "$;$");
        (void)newXSproto_portable("RPM::Database::FETCH", XS_RPM__Database_FETCH, file, "$$");
        (void)newXSproto_portable("RPM::Database::STORE", XS_RPM__Database_STORE, file, "$$$");
        (void)newXSproto_portable("RPM::Database::DELETE", XS_RPM__Database_DELETE, file, "$$");
        (void)newXSproto_portable("RPM::Database::CLEAR", XS_RPM__Database_CLEAR, file, "$");
        (void)newXSproto_portable("RPM::Database::EXISTS", XS_RPM__Database_EXISTS, file, "$$");
        (void)newXSproto_portable("RPM::Database::FIRSTKEY", XS_RPM__Database_FIRSTKEY, file, "$");
        (void)newXSproto_portable("RPM::Database::NEXTKEY", XS_RPM__Database_NEXTKEY, file, "$;$");
        (void)newXSproto_portable("RPM::Database::DESTROY", XS_RPM__Database_DESTROY, file, "$");
        (void)newXSproto_portable("RPM::Database::init", XS_RPM__Database_init, file, "$;$$");
        (void)newXSproto_portable("RPM::Database::rebuild", XS_RPM__Database_rebuild, file, "$;$");
        cv = newXSproto_portable("RPM::Database::find_by_group", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_GROUP ;
        cv = newXSproto_portable("RPM::Database::find_by_package", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_NAME ;
        cv = newXSproto_portable("RPM::Database::find_what_conflicts", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_CONFLICTNAME ;
        cv = newXSproto_portable("RPM::Database::find_by_file", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = 0 ;
        cv = newXSproto_portable("RPM::Database::find_what_requires", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_REQUIRENAME ;
        cv = newXSproto_portable("RPM::Database::find_what_provides", XS_RPM__Database_find_by_file, file, "$$");
        XSANY.any_i32 = RPMTAG_PROVIDENAME ;
    }
#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

