/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.2210 from the
 * contents of Error.xs. Do not edit this file, edit Error.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

/* Autogenerated XS functions are static. */
#define XSUBPP_STATIC_XS

#line 1 "RPM/Error.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "RPM.h"

static CV* err_callback;

/*
  This was static, but it needs to be accessible from other modules, as well.
*/
SV* rpm_errSV;

/*
  This is a callback routine that the bootstrapper will register with the RPM
  lib so as to catch any errors. (I hope)
*/
static void rpm_catch_errors(void)
{
    /* Because rpmErrorSetCallback expects (void)fn(void), we have to declare
       our thread context here */
    dTHX;
    int error_code;
    const char* error_string;

    error_code = rpmErrorCode();
    error_string = rpmErrorString();

    /* Set the string part, first */
    sv_setpv(rpm_errSV, error_string);
    /* Set the IV part */
    sv_setiv(rpm_errSV, error_code);
    /* Doing that didn't erase the PV part, but it cleared the flag: */
    SvPOK_on(rpm_errSV);

    /* If there is a current callback, invoke it: */
    if (err_callback != Nullcv)
    {
        /* This is just standard boilerplate for calling perl from C */
        dSP;
        ENTER;
        SAVETMPS;
        PUSHMARK(sp);
        XPUSHs(sv_2mortal(newSViv(error_code)));
        XPUSHs(sv_2mortal(newSVpv((char*)error_string, strlen(error_string))));
        PUTBACK;

        /* The actual call */
        call_sv((SV *)err_callback, G_DISCARD);

        /* More boilerplate */
        SPAGAIN;
        PUTBACK;
        FREETMPS;
        LEAVE;
    }

    return;
}

static
SV* set_error_callback(pTHX_ SV* newcb)
{
    SV* oldcb;

    oldcb = (err_callback) ? newRV((SV *)err_callback) : newSVsv(&PL_sv_undef);

    if (SvROK(newcb)) newcb = SvRV(newcb);
    if (SvTYPE(newcb) == SVt_PVCV)
        err_callback = (CV *)newcb;
    else if (SvPOK(newcb))
    {
        STRLEN len;
        const char *name = SvPV(newcb, len);

        if (strstr(name, "::"))
            err_callback = get_cv(name, FALSE);
        else {
            SV *sv = sv_2mortal(newSVpvn("main::", 6));
            sv_catpvn(sv, name, len);
            err_callback = get_cv(SvPV_nolen(sv), FALSE);
        }
    }
    else
    {
        err_callback = Nullcv;
    }

    return oldcb;
}


#line 107 "RPM/Error.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)	S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage		S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 159 "RPM/Error.c"
static
XS(XS_RPM__Error_set_error_callback)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       croak_xs_usage(cv,  "newcb");
    {
	SV*	newcb = ST(0);
	SV *	RETVAL;
#line 102 "RPM/Error.xs"
    RETVAL = set_error_callback(aTHX_ newcb);
#line 175 "RPM/Error.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

static
XS(XS_RPM__Error_clear_errors)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 110 "RPM/Error.xs"
/* This is just to offer an easy way to clear both sides of $RPM::err */
    sv_setpv(rpm_errSV, "");
    sv_setiv(rpm_errSV, 0);
    SvPOK_on(rpm_errSV);
#line 198 "RPM/Error.c"
    }
    XSRETURN_EMPTY;
}

static
XS(XS_RPM__Error_rpm_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       croak_xs_usage(cv,  "code, message");
    {
	int	code = (int)SvIV(ST(0));
	char*	message = (char *)SvPV_nolen(ST(1));
#line 121 "RPM/Error.xs"
    rpmError(code, "%s", message);
#line 218 "RPM/Error.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
#if (__GNUC__ >= 4) && defined(__ELF__)
XS(boot_RPM__Error) __attribute__((visibility("default")));
#else
XS(boot_RPM__Error); /* prototype to pass -Wmissing-prototypes */
#endif
XS(boot_RPM__Error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK ;

        (void)newXSproto_portable("RPM::Error::set_error_callback", XS_RPM__Error_set_error_callback, file, "$");
        (void)newXSproto_portable("RPM::Error::clear_errors", XS_RPM__Error_clear_errors, file, "");
        (void)newXSproto_portable("RPM::Error::rpm_error", XS_RPM__Error_rpm_error, file, "$$");

    /* Initialisation Section */

#line 125 "RPM/Error.xs"
{
    rpm_errSV = get_sv("RPM::err", GV_ADD|GV_ADDMULTI);
    rpmErrorSetCallback(rpm_catch_errors);
    err_callback = Nullcv;
}

#line 264 "RPM/Error.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

